
Global loop,value, A, Sqr , SqrColor , mx, my, Square , NewPiece, Column, Row, temp,Score
Dim Board(80)
Dim PieceColor(80)
Dim PieceType(80)
Graphics 1200,700,16,2
SetBuffer BackBuffer()
ClsColor 0,0,0
MakePieces()
value = 1
loop = 1
Score = 0
NewPiece = 15
Setup()
; Main Loop

While loop = 1
  Delay 10

 
  BuildBoard()
  MakeSquares()
  DrawPiece(50,50,NewPiece)
  DisplayPieces()
  DisplayText()

  CheckMouse()
  SetScore()
  value=GetKey()
 
   If value = 32 Then 
     loop=0                 ; break out of loop
   End If

  VWait
  Flip

Wend
 

End

Function BuildBoard()

  Cls
  Color 0,0,255
  Rect 250,10,674,674,0
  Rect 252,12,670,670,0
  Color 40,0,50
  Rect 254,14,666,666,1

  Color 0,0,255
  Rect 262,22,650,650,0

  Color 255,10,10
  Rect 264,24,646,646,0

  Color 255,255,255
  Rect 266,26,642,642,0


End Function

Function MakeSquares()
 Local x,y,a,b,size
 x = 267 : y=27 : size = 80
 For a = 1 To 8

     For b = 1 To 8
          Rect x,y,size,size,0
          y=y+size
     Next 
     x=x+size
     y=27
 Next


End Function

Function MakePieces()
 Local a,b,c,cnt
  c=1
  cnt = 1
  Sqr = CreateImage(82,82,65)
  For a = 1 To 64
     SetColor(c)
     PieceColor(a) = c
        ; Colors =  1 to 8
     SetBuffer ImageBuffer(Sqr,a)
     Rect 10,10,80,80,1
     cnt = cnt + 1
     If cnt > 8 Then 
       cnt = 1
       c = c+ 1
     End If 
  Next

  For a = 1 To 64
     SetBuffer ImageBuffer(Sqr,a)

     Color 255,255,255
     Rect 12,12,68,68,0
     Rect 14,14,64,64,0
     Rect 16,16,60,60,0
     Rect 18,18,56,56,0
     
  
  Next
    Cambria =LoadFont("Cambria",72,False,False,False)
    SetFont Cambria
    b = 1
  For a = 1 To 64
      SetBuffer ImageBuffer(Sqr,a)
      Color 0,0,0
      Text 28,8, Chr$( b+64 )
      PieceType(a) = b
        ; Piece types are 1-8
      b = b + 1
      If b > 8 Then b=1
  Next  
  SetBuffer BackBuffer()
  FreeFont Cambria


End Function

Function DrawPiece(x,y,a)
 
   DrawImage Sqr,x,y,a

End Function

Function SetColor( a )
     If a = 1 Then   Color 60,255,50
     If a = 2 Then   Color 20,20,255
     If a = 3 Then   Color 250,50,50
     If a = 4 Then   Color 50,250,250
     If a = 5 Then   Color 250,50,250
     If a = 6 Then   Color 250,250,50
     If a = 7 Then   Color 150,20,180
     If a = 8 Then   Color 20,130,130
     SqrColor = a
     
End Function


Function DisplayPieces()
   Local x,y,a,b
   x= 261 : y=21
   For a = 1 To 64
     b= Board(a)
    If b > 0 Then 
     DrawImage Sqr,x,y,b
    End If 
     x= x + 80
     If x> 900 Then 
       x = 261
       y = y + 80
     End If 
   Next 
End Function

Function DisplayText()
 
  Text 10,200," To play the game, click on "
  Text 5,215," am empty square near a piece"
  Text 5,230," that in some way matches the"
  Text 5,245," test piece located at the "
  Text 5,260," upper left."
  Text 10,275," Some combinations are worth"
  Text 5,290," more points than others."
  Text 5,320," http://rb23.yolasite.com " 


End Function


Function Setup()
    Board(2) = 6
    Board(4) = 35
    Board(6) = 47
    Board(8) = 23
    Board(18) = 11
    Board(20) = 50
    Board(22) = 29
    Board(24) = 34
    Board(34) = 26
    Board(36) = 5
    Board(38) = 48
    Board(40) = 33
    Board(50) = 12
    Board(52) = 50
    Board(54) = 29
    Board(56) = 52


End Function

Function CheckMouse()
 Local a,b,c,x,y,x2,y2
 a = GetMouse() 
 If a > 0 Then 
     mx=MouseX() 
     my=MouseY()
     Square = 0
     x =  267 : x2 = 347 : y = 27 : y2 = 107 
     For b = 1 To 8
         If mx > x And mx < x2 Then Column = b
         x = x + 80
         x2 = x2 + 80
     Next 
     For c = 1 To 8
         If my > y And my < y2 Then Row = c
         y = y + 80
         y2 = y2 + 80
     Next      
     If Column > 0 Then 
        Square = row * 8 - 8 + Column
        SelectSquare(Square)
     End If 
 End If 
     ; Text 10,10, Str mx
     ; Text 10,20, Str my
     ; Text 10,30, Str Square
     ; Text 10,40, Str temp

End Function

Function SelectSquare(s)
  Local a,b,s2
  Local t1,t2,t3,t4,clr1,clr2,clr3,clr4
  type1 = PieceType(NewPiece)
  color1 = PieceColor(NewPiece)
  s2=0
  If Board(s) = 0 Then a = 1  
  If Column > 1 Then 
       t1 = PieceType( Board(s-1) ) : clr1 = PieceColor(Board(s-1))
       If type1 = t1 Or color1 = clr1 Then b = 1      
       If type1 = t1 Then s2 = s2 + 10
       If color1 = clr1 Then s2 = s2 + 5
      

  
  End If  
  If Column <8 Then
       t2 = PieceType( Board(s+1) ) : clr2 = PieceColor(Board(s+1))
       If type1 = t2 Or color1 = clr2 Then b = 1  
       If type1 = t2 Then s2 = s2 + 10 : s2=s2*3
       If color1 = clr2 Then s2 = s2 + 5 : s2=s2 * 2 
       

  End If  
  If Row > 1 Then 
       t3 = PieceType( Board(s-8) ) : clr3 = PieceColor(Board(s-8))
       If type1 = t3 Or color1 = clr3 Then b = 1  
       If type1 = t3 Then s2 = s2+ 10 : s2=s2*3

       If color1 = clr3 Then s2 = s2 + 5 : s2 = s2 * 2
      
  End If  
  If Row <8 Then 
       t4 = PieceType( Board(s+8) ) : clr4 = PieceColor(Board(s+8))
       If type1 = t4 Or color1 = clr4 Then b = 1  
       If type1 = t4 Then s2 = s2 + 10 : s2=s2*3

       If color1 = clr4 Then s2 = s2 + 5 : s2=s2*3

       
  End If
 
  
  Score = Score + s2  

  If b=1 And a=1 Then
    Board(s) = NewPiece
    NewPiece = NewPiece + 5
    If NewPiece > 64 Then 
        NewPiece = 1
    End If 
  End If
  

End Function

Function SetScore()

  Text 50,30, "SCORE:"
  Text 100,30, Score


End Function 


